#!perl

use strict;

use CGI;



use CGI::Carp qw(fatalsToBrowser);					

use CGI::Pretty qw(:html4);		


my $cgi = new CGI;

#ici avec xhtml strict mais pareil avec html 5


$cgi->default_dtd(

            '-//W3C//DTD XHTML 1.0 Strict//EN',

            'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd');





print $cgi->header( -charset=>'UTF-8'),

$cgi->start_html(

	-dtd=>'yes', 

	-title=>'Page Title',

	-style=>{'type'=>'text/css','src'=>'styleStock.css'}

);

my $request;	

my $query_string;	



if ($ENV{'REQUEST_METHOD'} eq "GET") {

	$request = $ENV{'QUERY_STRING'};

} elsif ($ENV{'REQUEST_METHOD'} eq "POST") {

	read(STDIN, $request,$ENV{'CONTENT_LENGTH'});

}



	
#récupération des données du formulaire	

my @noms_champ = $cgi->param();


my @contenu;

foreach my $champ (@noms_champ) { 

	push(@contenu ,$cgi->param($champ));

};


#affichage du tableau contenant les données du formulaire


my $taille = @contenu;

$taille -= 5;





my $nb = $taille/5;





my @Quant =();

my @Prix =();

my @Crus =();

my @Annee =();

my @Region=();

my $sr;

my $sc;

my $an;

my $q;

my $p;



my $j = 0;

for (my $i=0; $i < $nb; $i++){

	push(@Region, $contenu[$j]);

	$j++;

}




for (my $i=0; $i < $nb; $i++){

		push(@Crus, $contenu[$j++]);

	}



for (my $i=0; $i < $nb; $i++){

		push(@Quant, $contenu[$j++]);

	}



for (my $i=0; $i < $nb; $i++){

		push(@Prix, $contenu[$j++]);

	}



for (my $i=0; $i < $nb; $i++){

		push(@Annee, $contenu[$j++]);

	}



open (F,">vins.txt");

my $taille = @Quant;
my $i;

for ($i=0; $i < $nb; $i++){

	print F ($Region[$i]," ",$Crus[$i]," ",$Quant[$i]," ",$Prix[$i]," ",$Annee[$i]);

	print F "\n";	

}

close F;



open F, "<vins.txt" || die "F non trouv&eacute;\n";

my %Stock = ();

my @lignes = <F>;

while(<F>)

 {

  	push(@lignes,$_);

 }



for (@lignes){


	(my $region, my $vin, my $quant, my $prix, my $an) = split(/ /);


	my $rec = {};

	@Quant =  ();

	@Prix =  ();

	@Crus =  ();

	@Annee =  ();	

	if (exists $Stock{$region}) 

	{	

		my $rec = $Stock{$region}; 

		 for my $pinard ( @{ $rec->{Quant} } ) {		 

			push @Quant,$pinard;

		}

		for my $pinard ( @{ $rec->{Prix} } ) {		 

			push @Prix,$pinard;

		}

		for my $pinard ( @{ $rec->{Crus} } ) {		 

			push @Crus,$pinard;

		}

		for my $pinard ( @{ $rec->{Annee} } ) {		 

			push @Annee,$pinard;

		}

	}

	push @Quant,$quant;

	push @Prix,$prix;

	push @Crus,$vin;

	push @Annee,$an;

	$rec->{Quant} = [@Quant];	

	$rec->{Prix} = [@Prix];

	$rec->{Crus} = [@Crus];

	$rec->{Annee} = [@Annee];

	$Stock{ $region } = $rec;

}

close F;




my $somme = 0;

my $tva =  20.6;



my $nom = $contenu[$#contenu-4];

my $prenom =  $contenu[$#contenu-3];

my $adresse = $contenu[$#contenu-2];

my $date = $contenu[$#contenu];

print $cgi->h1($prenom," ",$nom,"<br />",$adresse);



print $cgi->h1("Voici votre derni&egrave;re commande de vin");

print $cgi->h3($date);

print $cgi->start_table();     

print $cgi->Tr(

			$cgi->th("Quantit&eacute;"),

			$cgi->th("Prix par bouteille <br />en &euro;"),

			$cgi->th("Cru"),

			$cgi->th("Ann&eacute;e"),

			$cgi->th("Total"),

		);



foreach my $cle ( keys %Stock ) {

		 my $rec = $Stock{$cle}; # pointeur temporaire

		 @Quant =  ();	

		 @Prix = ();

		 @Crus = ();

		 @Annee = ();	 

		 for my $person ( @{ $rec->{Quant} } ) {		 

			push @Quant,$person;

		}

		for my $person ( @{ $rec->{Prix} } ) {		 

			push @Prix,$person;

		}

		for my $person ( @{ $rec->{Crus} } ) {		 

			push @Crus,$person;

		}

		for my $person ( @{ $rec->{Annee} } ) {		 

			push @Annee,$person;

		}

		print $cgi->Tr(

			$cgi->td({-colspan=>'5'},$cle)

		);

		my $taille = @Quant;



		for (my $j=0; $j < $taille; $j++){

			print $cgi->Tr(

					$cgi->td({-style=>'border : solid blue 1px'},$Quant[$j]),

					$cgi->td({-style=>'border : solid blue 1px'},$Prix[$j]),

					$cgi->td({-style=>'border : solid blue 1px'},$Crus[$j]),

					$cgi->td({-style=>'border : solid blue 1px'},$Annee[$j]),

					$cgi->td({-style=>'border : solid blue 1px'},$Quant[$j]*$Prix[$j]),

			);

			$somme += $Quant[$j]*$Prix[$j];

		}

		

	};

	print $cgi->Tr(

			$cgi->td({-colspan=>'4'},"Total commande H.T."),

			$cgi->td($somme)

		);

	my $arrondi = sprintf("%.2f", ($somme*$tva)/100);

	print $cgi->Tr(

			$cgi->td({-colspan=>'4'},"Montant TVA"),

			$cgi->td($arrondi)

		);

	print $cgi->Tr(

			$cgi->td({-colspan=>'4'},"Montant TTC"),

			$cgi->td(sprintf("%.2f",$somme+(($somme*$tva)/100)))

		);

print $cgi->end_table();	


print "</p>\n</body>\n</html>\n";